unit hiGMouseHook;

interface

uses Windows, Messages, Kol, Share, Debug;

type
  ThiGMouseHook = class(TDebug)
   private
     FHandle,
     FMouseX,
     FMouseY: integer;  
   public
     _event_onMouseMove,
     _event_onMouseUp,
     _event_onMouseDown,
     _event_onMouseWhell: THI_Event;
     constructor Create;     
     destructor Destroy; override;
     procedure _var_MouseX(var _Data:TData; Index:word);     
     procedure _var_MouseY(var _Data:TData; Index:word);
     procedure _var_Handle(var _Data:TData; Index:word);          
 end;

implementation

type
  TMouseMoveHook = record
    case Integer of
    0: (Hook: HHOOK);
    1: (Timer: THandle);
  end;

  PMsLLHookStruct = ^TMsLLHookStruct;
  tagMSLLHOOKSTRUCT = packed record
    pt: TPoint;
    mouseData: DWORD;
    flags: DWORD;
    time: DWORD;
    dwExtraInfo: PDWORD;
  end;
  TMsLLHookStruct = tagMSLLHOOKSTRUCT;

var
  MouseMoveHook: TMouseMoveHook;
  sClass: LongInt; 

function LowLevelMouseProc(nCode: Integer; WParam: WPARAM; LParam: LPARAM): LRESULT; stdcall;
begin
  Result := CallNextHookEx(MouseMoveHook.Hook, nCode, WParam, LParam);
  if nCode = HC_ACTION then
  begin
    ThiGMouseHook(sClass).FHandle := WindowFromPoint(PMsLLHookStruct(LParam)^.pt);
    ThiGMouseHook(sClass).FMouseX := PMsLLHookStruct(LParam)^.pt.X;
    ThiGMouseHook(sClass).FMouseY := PMsLLHookStruct(LParam)^.pt.Y;    
    case WParam of 
      WM_MOUSEMOVE:   _hi_onEvent(ThiGMouseHook(sClass)._event_onMouseMove);
      WM_LBUTTONUP:   _hi_onEvent(ThiGMouseHook(sClass)._event_onMouseUp, 0);
      WM_RBUTTONUP:   _hi_onEvent(ThiGMouseHook(sClass)._event_onMouseUp, 1);
      WM_MBUTTONUP:   _hi_onEvent(ThiGMouseHook(sClass)._event_onMouseUp, 2);
      WM_LBUTTONDOWN: _hi_onEvent(ThiGMouseHook(sClass)._event_onMouseDown, 0);
      WM_RBUTTONDOWN: _hi_onEvent(ThiGMouseHook(sClass)._event_onMouseDown, 1);
      WM_MBUTTONDOWN: _hi_onEvent(ThiGMouseHook(sClass)._event_onMouseDown, 2);
      WM_MOUSEWHEEL:  _hi_onEvent(ThiGMouseHook(sClass)._event_onMouseWhell, smallint(PMsLLHookStruct(LParam)^.mouseData shr 16));
    end;
  end;
end;

constructor ThiGMouseHook.Create;
const
  WH_MOUSE_LL = 14;
begin
  inherited;
  sClass := LongInt(Self);
  MouseMoveHook.Hook := SetWindowsHookEx(WH_MOUSE_LL, @LowLevelMouseProc, HInstance, 0);
end;

destructor ThiGMouseHook.Destroy;
begin
  UnhookWindowsHookEx(MouseMoveHook.Hook);
  inherited;
end;

procedure ThiGMouseHook._var_MouseX;     
begin
  dtInteger(_Data, FMouseX);
end;

procedure ThiGMouseHook._var_MouseY;
begin
  dtInteger(_Data, FMouseY);
end;

procedure ThiGMouseHook._var_Handle; 
begin
  dtInteger(_Data, FHandle);
end;

end.